Dirac Video Codec

# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

# dirac::Picture Class Reference

A class for encapsulating all the data relating to a picture. More...

`#include <picture.h>`

Inheritance diagram for dirac::Picture:
[legend]
Collaboration diagram for dirac::Picture:
[legend]

List of all members.

## Public Member Functions

- Picture (const PictureParams &pp)
    Constructor.
- Picture (const Picture &cpy)
    Copy constructor. Private as not currently used [may want to implement reference counting later.].
- virtual ~Picture ()
    Destructor.
- Picture & operator= (const Picture &rhs)
    Assignment =. Private as not currently used [may want to implement reference counting later.].
- void Fill (ValueType val)
    Picture Fill.
- PictureParams & GetPparams () const
    Gets the picture parameters.
- void SetPictureSort (const PictureSort ps)
    Sets the picture sort.
- void SetPictureType (const PictureType ftype)
    Sets the picture type.
- void SetReferenceType (const ReferenceType rtype)
    Sets the picture type.
- void ReconfigPicture (const PictureParams &pp)
    Reconfigures to the new parameters.
- PicArray & Data (CompSort cs)
    Returns a given component.
- const PicArray & Data (CompSort cs) const
    Returns a given component.
- PicArray & UpData (CompSort cs)
    Returns a given upconverted component.
- const PicArray & UpData (CompSort cs) const
    Returns a given upconverted component.
- const CoeffArray & WltData (CompSort c) const
    Returns the wavelet coefficient data.
- CoeffArray & WltData (CompSort c)
    Returns the wavelet coefficient data.
- void InitWltData (const int transform_depth)
    Initialises the wavelet coefficient data arrays;.
- void Clip ()
    Clip the data to prevent overshoot.
- void ClipUpData ()
    Clip the upconverted data to prevent overshoot.

## Protected Member Functions

- virtual void Init ()
    Initialises the picture once the picture parameters have been set.
- virtual void ClearData ()
    Delete all the data.
- void ClipComponent (PicArray &pic_data, CompSort cs) const
    Clip an individual component.

## Protected Attributes

- PictureParams m_pparams
- PicArray * m_pic_data [3]
- PicArray * m_up_pic_data [3]
- CoeffArray m_wlt_data [3]

## Detailed Description

A class for encapsulating all the data relating to a picture - all the component data, including upconverted data.

## Constructor & Destructor Documentation

dirac::Picture::Picture | ( | const PictureParams & | pp | ) |

Constructor initialises the picture parameters and the data

dirac::Picture::Picture | ( | const Picture & | cpy | ) |

virtual dirac::Picture::~Picture | ( |  | ) | `[virtual]`

## Member Function Documentation

Picture& dirac::Picture::operator= | ( | const Picture & | rhs | ) |

void dirac::Picture::Fill | ( | ValueType | val | ) |

Initialise contents of picture with value provided

PictureParams& dirac::Picture::GetPparams | ( |  | ) | const`[inline]`

References m_pparams.

void dirac::Picture::SetPictureSort | ( | const PictureSort | ps | ) | `[inline]`

References m_pparams, and dirac::PictureParams::SetPicSort().

void dirac::Picture::SetPictureType | ( | const PictureType | ftype | ) | `[inline]`

References m_pparams, and dirac::PictureParams::SetPictureType().

void dirac::Picture::SetReferenceType | ( | const ReferenceType | rtype | ) | `[inline]`

References m_pparams, and dirac::PictureParams::SetReferenceType().

void dirac::Picture::ReconfigPicture | ( | const PictureParams & | pp | ) |

PicArray& dirac::Picture::Data | ( | CompSort | cs | ) | `[inline]`

References m_pic_data.

const PicArray& dirac::Picture::Data | ( | CompSort | cs | ) | const`[inline]`

References m_pic_data.

PicArray& dirac::Picture::UpData | ( | CompSort | cs | ) |

const PicArray& dirac::Picture::UpData | ( | CompSort | cs | ) | const

const CoeffArray& dirac::Picture::WltData | ( | CompSort | c | ) | const`[inline]`

References m_wlt_data.

CoeffArray& dirac::Picture::WltData | ( | CompSort | c | ) | `[inline]`

References m_wlt_data.

void dirac::Picture::InitWltData | ( | const int | transform_depth | ) |

void dirac::Picture::Clip | ( |  | ) |

Clips the data to lie between 0 and (1<<video_depth)-1

void dirac::Picture::ClipUpData | ( |  | ) |

Clips the upconverted data to lie between 0 and (1<<video_depth)-1

virtual void dirac::Picture::Init | ( |  | ) | `[protected, virtual]`

virtual void dirac::Picture::ClearData | ( |  | ) | `[protected, virtual]`

Reimplemented in dirac::EncPicture.

void dirac::Picture::ClipComponent | ( | PicArray & | pic_data,
|  | CompSort | cs |
| ) |  |  | const`[protected]`

## Member Data Documentation

PictureParams dirac::Picture::m_pparams`[mutable, protected]`

Referenced by GetPparams(), SetPictureSort(), SetPictureType(), and SetReferenceType().

PicArray* dirac::Picture::m_pic_data[3]`[protected]`

Referenced by Data().

PicArray* dirac::Picture::m_up_pic_data[3]`[mutable, protected]`

CoeffArray dirac::Picture::m_wlt_data[3]`[protected]`

Referenced by WltData().

The documentation for this class was generated from the following file:

- picture.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.